$!-----------------------------------------------------------------------------
$! INSTALL.COM
$!
$! Install (most of) the CSWS PHP kit, build PHPWASD.EXE and copy the example
$! PHP scripts into the [CGI-BIN] directory.
$!
$!   HT_ROOT:[PHP]             PHP.INI configuration file
$!   HT_ROOT:[PHP.BIN]         PHP.EXE and PHPSHR.EXE (from CSWS kit)
$!   HT_ROOT:[PHP.EXTENSIONS]  PHP extension sharable images (from CSWS kit)
$!   HT_ROOT:[PHP.SCRIPTS]     example PHP scripts (from CSWS kit)
$!   HT_ROOT:[CGI-BIN]         *.PHP scripts (copied from [PHP.SCRIPTS])
$!   HT_ROOT:[AXP-BIN]         PHPWASD.EXE 
$!
$! 19-FEB-2005  MGD  bugfix; brain-dead P1 handling (thanks Rene Mendoza)
$! 22-JAN-2005  MGD  some refinements
$! 21-FEB-2004  MGD  CSWS PHP 1.2, PHPWASD.COM
$! 18-APR-2003  MGD  add CSWS PHP v1.1 update 1 (as "UPDATE111")
$! 10-JAN-2003  MGD  update
$! 26-DEC-2002  MGD  CSWS PHP v1.1
$! 19-JAN-2002  MGD  initial
$!-----------------------------------------------------------------------------
$ say = "write sys$output"
$ ss$_abort = 44
$!
$ arch_name = f$edit(f$getsyi("arch_name"),"upcase")
$ if arch_name .eqs. "ALPHA" then arch_name = "AXP"
$!
$ if arch_name .eqs. "VAX"
$ then
$ type sys$input

             **************************************************
             *  THIS PROCEDURE MAY ONLY BE USED ON ALPHA VMS  *
             **************************************************

$    exit ss$_abort
$ endif
$!
$ if f$search("ht_exe:sechan.exe") .eqs. ""
$ then
$    type sys$input

                           ***********************
                           *  WASD 8.1 OR LATER  *
                           ***********************

This kit is only suitable for WASD 8.1 or later.
Please update your site (for this and other reasons) ASAP!

$    exit ss$_abort
$ endif
$!
$ if p1 .nes. "INSTALL" .and. p1 .nes. "UPDATE" .and. -
     p1 .nes. "REMOVE" .and. p1 .nes. "PHP"  .and. p1 .nes. "SECURE" 
$ then
$    p2 = p1
$    p1 = "INSTALL"
$ endif
$!
$ type sys$input

                   Copyright (C) 2002-2005 Mark G.Daniel.
 This package (all associated programs), comes with ABSOLUTELY NO WARRANTY.
        This is free software, and you are welcome to redistribute it
     under the conditions of the GNU GENERAL PUBLIC LICENSE, version 2.

$ if p1 .eqs. "INSTALL"
$ then
$    type sys$input
                         ***************************
                         *  INSTALL WASD PHP V1.3  *
                         ***************************

This procedure installs a PORTION of the CSWS PHP 1.2 PCSI kit into the WASD
package directory tree as HT_ROOT:[PHP] with [.BIN], [.EXTENSIONS] and
[.SCRIPTS] subdirectories.  The WASD PHP engine interface will then be linked 
against the CSWS PHP shareable image.  This image is copied to [AXP-BIN] and
the example scripts in [PHP.SCRIPTS] into [CGI-BIN].
                          
The WASD PHP interface can be updated using ..... $ @INSTALL UPDATE
This installation can be removed using .......... $ @INSTALL REMOVE
The CSWS PHP kit can be updated (careful!) ...... $ @INSTALL PHP
The CSWS PHP kit security can be modified ....... $ @INSTALL SECURE

$    read sys$command /prompt="Continue? [N]: " response
$    say ""
$    if .not. response then exit
$!
$ endif
$!
$ if p1 .eqs. "INSTALL" .or. p1 .eqs. "PHP"
$ then
$!
$    if p2 .eqs. "" .or. f$search("''p2'*CSWS_PHP*.PCSI") .eqs. ""
$    then
$       type sys$input
                       *******************************
                       *  LOCATION OF CSWS_PHP KIT?  *
                       *******************************

Use P1 to specify the location of the CSWS_PHP kit.

  $ @INSTALL.COM [INSTALL|PHP] device:[directory]

$       exit ss$_abort
$    endif
$!
$    source = ""
$    if p1 .nes. "" then source = "/source=''p1'"
$!
$    say "Creating required directories ..."
$    create = "create"
$    create /directory /log ht_root:[php.bin]
$    create /directory /log ht_root:[php.extensions]
$    create /directory /log ht_root:[php.scripts]
$!
$    product = "product"
$!
$    type sys$input

                           **********************
                           *  CSWS_PHP VERSION  *
                           **********************

Installing (the highest) version ...
$    product find csws_php 'source'
$    say ""
$    read sys$command /prompt="Continue? [N]: " response
$    say ""
$    if .not. response then exit
$!
$    say ""
$    say "Extracting PHPSHR.EXE ..."
$    define /user sys$command sys$input
$    product extract file csws_php -
     /select=[apache.php.bin]phpshr.exe -
     /destination=ht_root:[php.bin] 'source'
$    say ""
$    say "Extracting PHP.EXE ..."
$    define /user sys$command sys$input
$    product extract file csws_php -
     /select=[apache.php.bin]php.exe -
     /destination=ht_root:[php.bin] 'source'
$    say ""
$    say "Extracting extension sharable images ..."
$    define /user sys$command sys$input
$    product extract file csws_php -
     /select=[apache.php.extensions]*.exe -
     /destination=ht_root:[php.extensions] 'source'
$    say ""
$    say "Extracting example scripts ..."
$    define /user sys$command sys$input
$    product extract file csws_php -
     /select=[apache.php.scripts]*.php -
     /destination=ht_root:[php.scripts] 'source'
$!
$ endif
$!
$ if p1 .eqs. "INSTALL" .or. p1 .eqs. "SECURE"
$ then
$    type sys$input
$    sechan = "$ht_exe:sechan"
$!   (check if it's a version that supports /permit)
$    def /user sys$output nl:
$    def /user sys$error nl:
$    sechan /version
$    if f$type(sechan_version) .nes. ""
$    then
$!      (yes, it does; v1.2.0 or later)
$       scriptingAccountLoop:
$          type sys$input
                           ***********************
                           *  SCRIPTING ACCOUNT  *
                           ***********************

By default access to HT_ROOT:[PHP...] is granted to WASD_HTTP_SERVER (the
server account rights identifier) and WASD_HTTP_NOBODY (the scripting account
rights identifier.

If this site's PHP scripting is executed under a non-default WASD account (i.e.
something other than HTTP$NOBODY) then this needs to be granted access instead.

$          response = ""
$          read sys$command /prompt="Account? [WASD_HTTP_NOBODY]: " response
$          say ""
$          if response .eqs. "" then response = "WASD_HTTP_NOBODY"
$          if f$identifier(response,"name_to_number") .eq. 0
$          then
$             say "ERROR: identifier not found"
$             say ""
$             goto scriptingAccountLoop
$          endif
$       endScriptingAccountLoop:
$       say "Setting HT_ROOT:[PHP...] security ..."
$       sechan /delete ht_root:[000000]php.dir
$       sechan /delete ht_root:[php...]*.*;*
$       sechan /permit='response' /read ht_root:[000000]php.dir
$       sechan /permit='response' /read ht_root:[php...]*.*;*
$       sechan /server /read ht_root:[000000]php.dir
$       sechan /server /read ht_root:[php...]*.dir
$       sechan /noworld /none ht_root:[000000]php.dir
$       sechan /noworld /none ht_root:[php...]*.*;*
$    else
$!      (pre-v1.2.0)
$       sechan /asif=CGI-BIN ht_root:[000000]php.dir
$       sechan /asif=CGI-BIN ht_root:[php...]*.*;*
$    endif
$    say ""
$!
$ endif
$!
$ if p1 .eqs. "INSTALL"
$ then
$!
$!   (define logical names for sharable images)
$    @ht_root:[src.php]php_startup
$!
$!   (link PHPWASD.EXE)
$    @ht_root:[src.php]build_phpwasd
$!
$    say "Copying files ..."
$    copy = "copy/log"
$    copy ht_exe:phpwasd.exe ht_root:[axp-bin]
$    copy ht_root:[src.php]phpwasd.com ht_root:[axp-bin]
$    copy ht_root:[php.scripts]*.php ht_root:[cgi-bin]
$    copy ht_root:[src.php]php.ini ht_root:[php]
$    copy ht_root:[src.php]webserverspy.php ht_root:[cgi-bin]
$    say ""
$!
$ endif
$!
$ if p1 .eqs. "UPDATE"
$ then
$    type sys$input
                         **************************
                         *  UPDATE WASD PHP V1.3  *
                         **************************

This procedures updates the WASD components of the PHP interface.
The WASD PHP interface (script) is linked against the existing CSWS PHP
shareable image.  This image is copied to [AXP-BIN].

$    read sys$command /prompt="Continue? [N]: " response
$    say ""
$    if .not. response then exit
$!
$!   (link PHPWASD.EXE)
$    @ht_root:[src.php]build_phpwasd
$!
$    copy = "copy/log"
$    copy ht_exe:phpwasd.exe ht_root:[axp-bin]
$    copy ht_root:[src.php]phpwasd.com ht_root:[axp-bin]
$    say ""
$!
$ endif
$!
$ if p1 .eqs. "REMOVE"
$ then
$    type sys$input
                            *********************
                            *  REMOVE WASD PHP  *
                            *********************

This procedure deletes the CSWS PHP files used to a support WASD PHP and
files from the WASD scripting environment.  As this is DELETION and final
please ensure you have copied any files you may require to keep (especially
any local PHP scripts from [CGI-BIN]).

  HT_ROOT:[PHP...]*.*;*
  HT_ROOT:[AXP-BIN]PHPWASD.EXE;*
  HT_ROOT:[AXP-BIN]PHPWASD.COM;*
  HT_ROOT:[CGI-BIN]*.PHP;*

Note: it does not delete the HT_ROOT:[SRC.PHP] tree.

$    read sys$command /prompt="Continue? [N]: " response
$    say ""
$    if .not. response then exit
$    delete = "delete/log"
$    delete ht_root:[php...]*.*;*,ht_root:[php...]*.*;*,-
            ht_root:[php...]*.*;*,ht_root:[000000]php.dir;*
$    delete ht_root:[axp-bin]phpwasd.exe;*
$    delete ht_root:[axp-bin]phpwasd.com;*
$    delete ht_root:[cgi-bin]*.php;*
$    say ""
$ endif
$!
$ type sys$input
                            *********************
                            *  C O M P L E T E  *
                            *********************

$ exit
$!-----------------------------------------------------------------------------
